#ifndef XS_TEST_SERVER_H_INCLUDED
#define XS_TEST_SERVER_H_INCLUDED

#include <nlohmann/json.hpp>

#include <memory>
#include <string>


namespace xs { namespace test
{
    class Service final
    {
    public:
        enum class Type {
            COMMAND, EVENT
        };

    public:
        Service() = delete;
        Service(const Service&) = delete;
        Service(Service&&) noexcept = default;
        ~Service() noexcept = default;

        Service& operator=(const Service&) = delete;
        Service& operator=(Service&&) = delete;

        explicit Service(const nlohmann::json& object);
        static bool verify(const nlohmann::json& object) noexcept;

        bool isCommand() const noexcept;
        bool isEvent() const noexcept;

    private:
        Service(Type type, std::string name, nlohmann::json response) noexcept;

    public:
        Type type_;
        std::string name_;
        nlohmann::json response_;
    };
} }

#endif
