#ifndef XS_TEST_TESTER_H_INCLUDED
#define XS_TEST_TESTER_H_INCLUDED

#include <memory>
#include <unordered_map>

#include <boost/filesystem.hpp>

#include "positivegrid/exchange_server.h"
#include "test/Config.h"


namespace xs { namespace test
{
    class Tester final
    {
    public:
        Tester() = delete;
        ~Tester() noexcept = default;

        Tester(const Tester&) = delete;
        Tester(Tester&&) = delete;

        Tester& operator=(const Tester&) = delete;
        Tester& operator=(Tester&&) = delete;

        explicit Tester(const boost::filesystem::path& file);

        void wait() noexcept;

    private: 
        std::string onCommand(const std::string& name, const std::string& params) noexcept;
        void onEvent(const std::string& name, const std::string& params) noexcept;

        void registerServices() noexcept;

    public:
        Config config_;
        ExchangeServer server_;
        std::unordered_map<std::string, const Service*> acceptCommands_;
        std::unordered_map<std::string, const Service*> acceptEvents_;
    };
} }

#endif
